{$S-,Q-,R-,I-,A+,X+}
program Emul601;
uses int601fn,crt;

procedure open_file;
label 1;
type
  HeadPgmType = packed record {  PGM-䠩 }
    Magic,	{  'eZ' = $a55a }
    ReloCnt,	{ ᫮ ⮢  ⠡ ६饭 }
    ReloCS,	{ 饭 ணࠬ  }
    LenCS,	{  ணࠬ  }
    PgmIP : word; { . 室. 窨   .  砫 }
      {  $0a..$0f - १ࢨ஢,   ﬨ }
    Reserved : packed array [$0a..$0f] of char
  end;
var adres : word;
  ftest : file;
  Head : HeadPgmType;
begin
  if paramcount<1 then
  begin
    writeln('EMUL601 file'); halt
  end;
  assign(f,paramstr(1)); reset(f);
  if IOresult<>0 then
  begin
    writeln('File not found'); halt
  end;
  if filesize(f)<=SizeOf(Head) then goto 1;
  close(f); assign(ftest,paramstr(1)); reset(ftest,1);
  BlockRead(ftest,Head,SizeOf(Head)); close(ftest);
  assign(f,paramstr(1)); reset(f);
  With Head do if Magic=$5aa5 then
  begin
    { ⠥ PGM-䠩: }
    ReloCnt:=swap(ReloCnt); ReloCS:=swap(ReloCS);
    LenCS:=swap(LenCS); PgmIP:=swap(PgmIP);
    adres:=$b3e5-filesize(f);
    for ps:=0 to filesize(f)-1 do
    begin
      read(f,ch); poke(adres+ps,ch)
    end;
    { ன ᮢ ( ⠡ ६饭) }
    for tmp21:=1 to ReloCnt do doke(Adres+ReloCS+
      deek(adres+$10+(tmp21-1)*2),deek(Adres+ReloCS+
        deek(adres+$10+(tmp21-1)*2))+adres+ReloCS);
    adr:=ReloCS+Adres+PgmIP; { 砫  }
    sp:=ReloCS+Adres-1 { 砫쭮 祭 ⥪ }
  end
  else 1: begin
    { ⠥ CMD-䠩: }
    for ps:=0 to filesize(f)-1 do
    begin
      read(f,ch); poke($100+ps,ch)
    end;
    adr:=$100; { 砫  }
    sp:=$b3e5 { 砫쭮 祭 ⥪ }
  end;
  bsp:=sp; close(f)
end;

procedure Make_CC;
{ ࠭ 䫠  䫠 ॣ }
begin
  poke(4,192+ord(Half_carry)*32+ord(Int_disable)*16+
    +ord(Negative)*8+ord(Zero)*4+ord(oVerflow)*2+ord(Carry))
end;

procedure cc_to_flags;
{ ⠭ 䫠  ᮮ⢥⢨  䫠 ॣ஬ }
var c:byte;
begin
  i:=0; c:=Peek(4);
  repeat
    inc(i); sc[i]:=c mod 2; c:=c div 2
  until c<1;
  if sc[1]=1 then Carry:=true else Carry:=false;
  if sc[2]=1 then oVerflow:=true else oVerflow:=false;
  if sc[3]=1 then Zero:=true else Zero:=false;
  if sc[4]=1 then Negative:=true else Negative:=false;
  if sc[5]=1 then Int_disable:=true else Int_disable:=false;
  if sc[6]=1 then Half_carry:=true else Half_carry:=false
end;

procedure dec_test(per1,per2:byte;
  var vf,cf:boolean); assembler;
{ 뢠  8-⭮ ⠭
   ⠭ 䫠 Carry  oVerflow }
asm
	mov	ah,per1
	sub	ah,per2
	pushf
	jo	@@1
	mov	al,false
	jmp	@@2
@@1:	mov	al,true
@@2:	les	di,vf
	stosb
	popf
	jc	@@7
	mov	al,false
	jmp	@@8
@@7:	mov	al,true
@@8:	les	di,cf
	stosb
end;

procedure inc_test(per1,per2:byte;
  var vf,cf,hf:boolean); assembler;
{ 뢠  8-⭮ ᫮ 
  ⠭ 䫠 Carry, Half_carry  oVerflow }
asm
	mov	al,per1
	add	al,per2
	pushf
	jo	@@1
	mov	al,false
	jmp	@@2
@@1:	mov	al,true
@@2:	les	di,vf
	stosb
	popf
	pushf
	jc	@@7
	mov	al,false
	jmp	@@8
@@7:	mov	al,true
@@8:	les	di,cf
	stosb
	popf
	lahf
	test	ah,16
	je	@@9
	mov	al,true
	jmp	@@10
@@9:	mov	al,false
@@10:	les	di,hf
	stosb
end;

procedure rol(per1:byte; crf:boolean;
  var res:byte; var vf,cf:boolean); assembler;
{ 뢠  横᪮ ᤢ ROL  ⠭
  䫠 Carry  oVerflow  祭 १ }
asm
	mov	al,per1
	mov	ah,crf
	cmp	ah,true
	je	@@11
	clc
	jmp	@@12
@@11:	stc
@@12:	rcl	al,1
	pushf
	les	di,res
	stosb
	popf
	pushf
	jo	@@1
	mov	al,false
	jmp	@@2
@@1:	mov	al,true
@@2:	les	di,vf
	stosb
	popf
	pushf
	jc	@@7
	mov	al,false
	jmp	@@8
@@7:	mov	al,true
@@8:	les	di,cf
	stosb
end;

procedure asl(per1:byte; var res:byte;
  var vf,cf:boolean); assembler;
{ 뢠  䬥᪮ ᤢ ASL  -
   䫠 Carry  oVerflow  祭 १ }
asm
	mov	al,per1
	sal	al,1
	pushf
	les	di,res
	stosb
	popf
	pushf
	jo	@@1
	mov	al,false
	jmp	@@2
@@1:	mov	al,true
@@2:	les	di,vf
	stosb
	popf
	pushf
	jc	@@7
	mov	al,false
	jmp	@@8
@@7:	mov	al,true
@@8:	les	di,cf
	stosb
end;

procedure asr(per1:byte; var res:byte;
  var vf,cf:boolean); assembler;
{ 뢠  䬥᪮ ᤢ ASR  -
   䫠 Carry  oVerflow  祭 १ }
asm
	mov	al,per1
	sar	al,1
	pushf
	les	di,res
	stosb
	popf
	pushf
	jo	@@1
	mov	al,false
	jmp	@@2
@@1:	mov	al,true
@@2:	les	di,vf
	stosb
	popf
	pushf
	jc	@@7
	mov	al,false
	jmp	@@8
@@7:	mov	al,true
@@8:	les	di,cf
	stosb
end;

procedure ror(per1:byte; crf:boolean;
  var res:byte; var vf,cf:boolean); assembler;
{ 뢠  横᪮ ᤢ ROR  ⠭
  䫠 Carry  oVerflow  祭 १ }
asm
	mov	al,per1
	mov	ah,crf
	cmp	ah,true
	je	@@11
	clc
	jmp	@@12
@@11:	stc
@@12:	rcr	al,1
	pushf
	les	di,res
	stosb
	popf
	pushf
	jo	@@1
	mov	al,false
	jmp	@@2
@@1:	mov	al,true
@@2:	les	di,vf
	stosb
	popf
	pushf
	jc	@@7
	mov	al,false
	jmp	@@8
@@7:	mov	al,true
@@8:	les	di,cf
	stosb
end;

procedure lsr(per1:byte; var res:byte);
{ 뢠  ᪮ ᤢ LSR  -
   䫠 Carry  oVerflow  祭 १ }
begin
  res:=per1 div 2;
  if per1 mod 2 = 0 then Carry:=false else Carry:=true;
  Negative:=true; oVerflow:=Carry
end;

procedure dec_adjust(per1:byte; crf,hcf:boolean;
  var per2:byte; var cf,vf:boolean); assembler;
{ 뢠  筮 ४樨 ᫮ DAA 
  ⠭ 䫠 Carry  oVerflow  祭 १ }
asm
	mov	al,per1
	mov	ah,hcf
	cmp	ah,true
	je	@@5
	lahf
	and	ah,239
	sahf
	jmp	@@6
@@5:	lahf
	or	ah,16
	sahf
@@6:	pushf
	mov	ah,crf
	cmp	ah,true
	je	@@3
	popf
	clc
	jmp	@@4
@@3:	popf
	stc
@@4:	daa
	pushf
	les	di,per2
	stosb
	popf
	pushf
	jo	@@1
	mov	al,false
	jmp	@@2
@@1:	mov	al,true
@@2:	les	di,vf
	stosb
	popf
	jc	@@7
	mov	al,false
	jmp	@@8
@@7:	mov	al,true
@@8:	les	di,cf
	stosb
end;

procedure test_cpx(per1,per2:word;
  var vf:boolean); assembler;
{ 뢠  16-⭮ ⠭
   ⠭ 䫠 oVerflow }
asm
	mov	ax,per1
	sub	ax,per2
	jo	@@1
	mov	al,false
	jmp	@@2
@@1:	mov	al,true
@@2:	les	di,vf
	stosb
end;

procedure test_zs(sm:byte);
{ ⠭ 䫠 Zero  Negative
  ᫥ 8-⮢ 権 }
begin
  if sm=0 then Zero:=true else Zero:=false;
  if sm<$80 then Negative:=false else Negative:=true
end;

procedure ts16_zs(sm:word);
{ ⠭ 䫠 Zero  Negative
  ᫥ 16-⮢ 権 }
begin
  if sm=0 then Zero:=true else Zero:=false;
  if hi(sm)<$80 then Negative:=false else Negative:=true
end;

function rel_adres(rc:byte):word;
{   室  ⪨ 室 }
begin
  if rc>127 then rel_adres:=adr+rc-254
    else rel_adres:=adr+rc+2
end;

procedure Processor;
{  : 믮 樨 SH 
  ⥪饬  ADR }
begin
  case sh of
{ ---  /  --- }
$1b: begin {ABA}
  ua:=1; inc_test(B,A,oVerflow,Carry,Half_carry);
  A:=B+A; test_zs(A)
end;
$48: begin {ASLA}
  ua:=1; asl(A,A,oVerflow,Carry); test_zs(A)
end;
$58: begin {ASLB}
  ua:=1; asl(B,B,oVerflow,Carry); test_zs(B)
end;
$47: begin {ASRA}
  ua:=1; asr(A,A,oVerflow,Carry); test_zs(A)
end;
$57: begin {ASRB}
  ua:=1; asr(B,B,oVerflow,Carry); test_zs(B)
end;
$11: begin {CBA}
  ua:=1; dec_test(A,B,oVerflow,Carry); test_zs(A-B)
end;
$0c: begin {CLC}
  ua:=1; Carry:=false
end;
$0e: begin {CLI}
  ua:=1; Int_disable:=false
end;
$4f: begin {CLRA}
  ua:=1; A:=0; Negative:=false;
  oVerflow:=false; Zero:=true; Carry:=false
end;
$5f: begin {CLRB}
  ua:=1; B:=0; Negative:=false;
  oVerflow:=false; Zero:=true; Carry:=false
end;
$0a: begin {CLV}
  ua:=1; oVerflow:=false
end;
$43: begin {COMA}
  ua:=1; A:=not A; Carry:=true; oVerflow:=false; test_zs(A)
end;
$53: begin {COMB}
  ua:=1; B:=not B; Carry:=true; oVerflow:=false; test_zs(B)
end;
$19: begin {DAA}
  ua:=1; dec_adjust(A,Carry,Half_carry,A,Carry,oVerflow);
  test_zs(A)
end;
$4a: begin {DECA}
  ua:=1; dec_test(A,1,oVerflow,Zero); dec(A); test_zs(A)
end;
$5a: begin {DECB}
  ua:=1; dec_test(B,1,oVerflow,Zero); dec(B); test_zs(B)
end;
$34: begin {DES}
  ua:=1; dec(sp)
end;
$09: begin {DEX}
  ua:=1; X:=Hi(X-1)*256+Lo(X-1);
  if X=0 then Zero:=true else Zero:=false
end;
$4c: begin {INCA}
  ua:=1; inc_test(A,1,oVerflow,Zero,Zero);
  inc(A); test_zs(A)
end;
$5c: begin {INCB}
  ua:=1; inc_test(B,1,oVerflow,Zero,Zero);
  inc(B); test_zs(B)
end;
$31: begin {INS}
  ua:=1; inc(sp)
end;
$08: begin {INX}
  ua:=1; X:=Hi(X+1)*256+Lo(X+1);
  if X=0 then Zero:=true else Zero:=false
end;
$44: begin {LSRA}
  ua:=1; lsr(A,A); test_zs(A)
end;
$54: begin {LSRB}
  ua:=1; lsr(B,B); test_zs(B)
end;
$40: begin {NEGA}
  ua:=1; dec_test(0,A,oVerflow,Carry); A:=-A; test_zs(A)
end;
$50: begin {NEGB}
  ua:=1; dec_test(0,B,oVerflow,Carry); B:=-B; test_zs(B)
end;
$36: begin {PSHA}
  ua:=1; dec(sp); poke(sp,A)
end;
$37: begin {PSHB}
  ua:=1; dec(sp); poke(sp,B)
end;
$32: begin {PULA}
  ua:=1; A:=peek(sp); inc(sp)
end;
$33: begin {PULB}
  ua:=1; B:=peek(sp); inc(sp)
end;
$49: begin {ROLA}
  ua:=1; rol(A,Carry,A,oVerflow,Carry); test_zs(A)
end;
$59: begin {ROLB}
  ua:=1; rol(B,Carry,B,oVerflow,Carry); test_zs(B)
end;
$46: begin {RORA}
  ua:=1; ror(A,Carry,A,oVerflow,Carry); test_zs(A)
end;
$56: begin {RORB}
  ua:=1; ror(B,Carry,B,oVerflow,Carry); test_zs(B)
end;
$3b: begin {RTI -   !}
  ua:=1;
end;
$39: begin {RTS}
  ua:=0; adr:=deek(sp); inc(sp,2)
end;
$10: begin {SBA}
  ua:=1; dec_test(A,B,oVerflow,Carry); A:=A-B; test_zs(A)
end;
$0d: begin {SEC}
  ua:=1; Carry:=true
end;
$0f: begin {SEI}
  ua:=1; Int_disable:=true
end;
$0b: begin {SEV}
  ua:=1; oVerflow:=true
end;
$3f: begin {INT}
  ua:=2;
  case peek(adr+1) of
    $00: int00; $01: int01; $02: int02; $03: int03;
    $04: int04; $05: int05; $06: int06; $07: int07;
    $09: int09; $0a: int0a; $10: int10; $11: int11;
    $12: int12; $13: int13; $14: int14; $15: int15;
    $16: int16; $17: int17; $18: int18; $19: int19;
    $1a: int1a; $1b: int1b; $1c: int1c; $1d: int1d;
    $1e: int1e; $1f: int1f; $20: int20; $21: int21;
    $22: int22; $23: int23; $24: int24; $25: int25;
    $26: int26; $27: int27; $28: int28; $29: int29;
    $2a: int2a; $2b: int2b; $2c: int2c; $2d: int2d;
    $2e: int2e; $2f: int2f; $30: int30; $31: int31;
    $35: int35; $36: int36; $37: int37; $38: int38;
    $39: int39; $3a: int3a; $3b: int3b; $3c: int3c;
    $3d: int3d; $40: int40; $41: int41; $42: int42;
    $43: int43; $44: int44; $45: int45; $46: int46;
    $47: int47; $48: int48; $49: int49; $4a: int4a;
    $4b: int4b; $4c: int4c; $4d: int4d; $4e: int4e;
    $4f: int4f; $50: int50; $51: int51; $52: int52;
    $53: int53; $54: int54; $55: int55; $56: int56;
    $57: int57; $58: int58; $5d: int5d; $5e: int5e;
    $60: int60; $61: int61; $63: int63; $64: int64;
    $65: int65; $66: int66; $67: int67; $6e: int6e;
    $6f: int6f
  end
end;
$16: begin {TAB}
  ua:=1; oVerflow:=false; B:=A; test_zs(B)
end;
$06: begin {TAP}
  ua:=1; Poke(4,A); cc_to_flags
end;
$17: begin {TBA}
  ua:=1; oVerflow:=false; A:=B; test_zs(A)
end;
$07: begin {TPA}
  ua:=1; A:=Peek(4)
end;
$4d: begin {TSTA}
  ua:=1; Carry:=false; oVerflow:=false; test_zs(A)
end;
$5d: begin {TSTB}
  ua:=1; Carry:=false; oVerflow:=false; test_zs(B)
end;
$30: begin {TSX}
  X:=Hi(sp+1)*256+Lo(sp+1); ua:=1
end;
$35: begin {TXS}
  ua:=1; sp:=X-1
end;
$3e: begin {WAI-   !}
  ua:=1; Int_disable:=true
end;
{ ---  --- }
$24: begin {BCC 8}
  if not Carry then
  begin
    ua:=0; adr:=rel_adres(peek(adr+1))
  end else ua:=2
end;
$25: begin {BCS 8}
  if Carry then
  begin
    ua:=0; adr:=rel_adres(peek(adr+1))
  end else ua:=2
end;
$27: begin {BEQ 8}
  if Zero then
  begin
    ua:=0; adr:=rel_adres(peek(adr+1))
  end else ua:=2
end;
$2c: begin {BGE 8}
  if not (Negative xor oVerflow) then
  begin
    ua:=0; adr:=rel_adres(peek(adr+1))
  end else ua:=2
end;
$2e: begin {BGT 8}
  if not (Zero or (Negative xor oVerflow))
  then begin
    ua:=0; adr:=rel_adres(peek(adr+1))
  end else ua:=2
end;
$22: begin {BHI 8}
  if not (Carry or Zero) then
  begin
    ua:=0; adr:=rel_adres(peek(adr+1))
  end else ua:=2
end;
$2f: begin {BLE 8}
  if Zero or (Negative xor oVerflow) then
  begin
    ua:=0; adr:=rel_adres(peek(adr+1))
  end else ua:=2
end;
$23: begin {BLS 8}
  if Carry or Zero then
  begin
    ua:=0; adr:=rel_adres(peek(adr+1))
  end else ua:=2
end;
$2d: begin {BLT 8}
  if Negative xor oVerflow then
  begin
    ua:=0; adr:=rel_adres(peek(adr+1))
  end else ua:=2
end;
$2b: begin {BMI 8}
  if Negative then
  begin
    ua:=0; adr:=rel_adres(peek(adr+1))
  end else ua:=2
end;
$26: begin {BNE 8}
  if not Zero then
  begin
    ua:=0; adr:=rel_adres(peek(adr+1))
  end else ua:=2
end;
$2a: begin {BPL 8}
  if not Negative then
  begin
    ua:=0; adr:=rel_adres(peek(adr+1))
  end else ua:=2
end;
$20: begin {BRA 8}
  ua:=0; adr:=rel_adres(peek(adr+1))
end;
$8d: begin {BSR 8}
  ua:=0; dec(sp,2);
  doke(sp,adr+2); adr:=rel_adres(peek(adr+1))
end;
$28: begin {BVC 8}
  if not oVerflow then
  begin
    ua:=0; adr:=rel_adres(peek(adr+1))
  end else ua:=2
end;
$29: begin {BVS 8}
  if oVerflow then
  begin
    ua:=0; adr:=rel_adres(peek(adr+1))
  end else ua:=2
end;
{ ---  --- }
$89: begin {ADCA #8}
  ua:=2; btmp:=Carry; inc_test(A+ord(btmp),peek(adr+1),
    oVerflow,Carry,Half_carry);
  A:=A+peek(adr+1)+ord(btmp); test_zs(A)
end;
$c9: begin {ADCB #8}
  ua:=2; btmp:=Carry; inc_test(B+ord(btmp),peek(adr+1),
    oVerflow,Carry,Half_carry);
  B:=B+peek(adr+1)+ord(btmp); test_zs(B)
end;
$8b: begin {ADDA #8}
  ua:=2; inc_test(A,peek(adr+1),oVerflow,Carry,Half_carry);
  A:=A+peek(adr+1); test_zs(A)
end;
$cb: begin {ADDB #8}
  ua:=2; inc_test(B,peek(adr+1),oVerflow,Carry,Half_carry);
  B:=B+peek(adr+1); test_zs(B)
end;
$84: begin {ANDA #8}
  ua:=2; A:=A and peek(adr+1); test_zs(A); oVerflow:=false
end;
$c4: begin {ANDB #8}
  ua:=2; B:=B and peek(adr+1); test_zs(B); oVerflow:=false
end;
$85: begin {BITA #8}
  ua:=2; oVerflow:=false; test_zs(A and peek(adr+1))
end;
$c5: begin {BITB #8}
  ua:=2; oVerflow:=false; test_zs(B and peek(adr+1))
end;
$81: begin {CMPA #8}
  ua:=2; dec_test(A,peek(adr+1),oVerflow,Carry);
  test_zs(A-peek(adr+1))
end;
$c1: begin {CMPB #8}
  ua:=2; dec_test(B,peek(adr+1),oVerflow,Carry);
  test_zs(B-peek(adr+1))
end;
$8c: begin {CPX #16}
  ua:=3; tmp21:=deek(adr+1);
  test_cpx(X,tmp21,oVerflow); ts16_zs(X-tmp21)
end;
$88: begin {EORA #8}
  ua:=2; A:=A xor peek(adr+1); test_zs(A); oVerflow:=false
end;
$c8: begin {EORB #8}
  ua:=2; B:=B xor peek(adr+1); test_zs(B); oVerflow:=false
end;
$86: begin {LDAA #8}
  ua:=2; A:=peek(adr+1); test_zs(A); oVerflow:=false
end;
$c6: begin {LDAB #8}
  ua:=2; B:=peek(adr+1); test_zs(B); oVerflow:=false
end;
$8e: begin {LDS #16}
  ua:=3; sp:=deek(adr+1); oVerflow:=false; ts16_zs(sp)
end;
$ce: begin {LDX #16}
  ua:=3; x:=deek(adr+1); oVerflow:=false; ts16_zs(X)
end;
$8a: begin {ORAA #8}
  ua:=2; A:=A or peek(adr+1); test_zs(A); oVerflow:=false
end;
$ca: begin {ORAB #8}
  ua:=2; B:=B or peek(adr+1); test_zs(B); oVerflow:=false
end;
$82: begin {SBCA #8}
  ua:=2; btmp:=Carry;
  dec_test(A-ord(btmp),peek(adr+1),oVerflow,Carry);
  A:=A-peek(adr+1)-ord(btmp); test_zs(A)
end;
$c2: begin {SBCB #8}
  ua:=2; btmp:=Carry;
  dec_test(B-ord(btmp),peek(adr+1),oVerflow,Carry);
  B:=B-peek(adr+1)-ord(btmp); test_zs(B)
end;
$80: begin {SUBA #8}
  ua:=2; dec_test(A,peek(adr+1),oVerflow,Carry);
  A:=A-peek(adr+1); test_zs(A)
end;
$c0: begin {SUBB #8}
  ua:=2; dec_test(B,peek(adr+1),oVerflow,Carry);
  B:=B-peek(adr+1); test_zs(B)
end;
{ ---  --- }
$99: begin {ADCA 8}
  ua:=2; btmp:=Carry; inc_test(A+ord(btmp),
    peek(peek(adr+1)),oVerflow,Carry,Half_carry);
  A:=A+peek(peek(adr+1))+ord(btmp); test_zs(A)
end;
$d9: begin {ADCB 8}
  ua:=2; btmp:=Carry; inc_test(B+ord(btmp),
    peek(peek(adr+1)),oVerflow,Carry,Half_carry);
  B:=B+peek(peek(adr+1))+ord(btmp); test_zs(B)
end;
$9b: begin {ADDA 8}
  ua:=2; inc_test(A,peek(peek(adr+1)),
    oVerflow,Carry,Half_carry);
  A:=A+peek(peek(adr+1)); test_zs(A)
end;
$db: begin {ADDB 8}
  ua:=2; inc_test(B,peek(peek(adr+1)),
    oVerflow,Carry,Half_carry);
  B:=B+peek(peek(adr+1)); test_zs(B)
end;
$94: begin {ANDA 8}
  ua:=2; A:=A and peek(peek(adr+1));
  test_zs(A); oVerflow:=false
end;
$d4: begin {ANDB 8}
  ua:=2; B:=B and peek(peek(adr+1));
  test_zs(B); oVerflow:=false
end;
$95: begin {BITA 8}
  ua:=2; oVerflow:=false; test_zs(A and peek(peek(adr+1)))
end;
$d5: begin {BITB 8}
  ua:=2; oVerflow:=false; test_zs(B and peek(peek(adr+1)))
end;
$91: begin {CMPA 8}
  ua:=2; dec_test(A,peek(peek(adr+1)),oVerflow,Carry);
  test_zs(A-peek(peek(adr+1)))
end;
$d1: begin {CMPB 8}
  ua:=2; dec_test(B,peek(peek(adr+1)),oVerflow,Carry);
  test_zs(B-peek(peek(adr+1)))
end;
$9c: begin {CPX 8}
  ua:=2; test_cpx(X,deek(peek(adr+1)),oVerflow);
  ts16_zs(X-deek(peek(adr+1)))
end;
$98: begin {EORA 8}
  ua:=2; A:=A xor peek(peek(adr+1));
  test_zs(A); oVerflow:=false
end;
$d8: begin {EORB 8}
  ua:=2; B:=B xor peek(peek(adr+1));
  test_zs(B); oVerflow:=false
end;
$96: begin {LDAA 8}
  ua:=2; A:=peek(peek(adr+1)); test_zs(A); oVerflow:=false
end;
$d6: begin {LDAB 8}
  ua:=2; B:=peek(peek(adr+1)); test_zs(B); oVerflow:=false
end;
$9e: begin {LDS 8}
  ua:=2; sp:=deek(peek(adr+1)); oVerflow:=false; ts16_zs(sp)
end;
$de: begin {LDX 8}
  ua:=2; X:=deek(peek(adr+1)); oVerflow:=false; ts16_zs(X)
end;
$9a: begin {ORAA 8}
  ua:=2; A:=A or peek(peek(adr+1));
  test_zs(A); oVerflow:=false
end;
$da: begin {ORAB 8}
  ua:=2; B:=B or peek(peek(adr+1));
  test_zs(B); oVerflow:=false
end;
$92: begin {SBCA 8}
  ua:=2; btmp:=Carry; dec_test(A-ord(btmp),
    peek(peek(adr+1)),oVerflow,Carry);
  A:=A-peek(peek(adr+1))-ord(btmp); test_zs(A)
end;
$d2: begin {SBCB 8}
  ua:=2; btmp:=Carry; dec_test(B-ord(btmp),
    peek(peek(adr+1)),oVerflow,Carry);
  B:=B-peek(peek(adr+1))-ord(btmp); test_zs(B)
end;
$97: begin {STAA 8}
  ua:=2; poke(peek(adr+1),A); test_zs(A); oVerflow:=false
end;
$d7: begin {STAB 8}
  ua:=2; poke(peek(adr+1),B); test_zs(B); oVerflow:=false
end;
$9f: begin {STS 8}
  ua:=2; doke(peek(adr+1),sp); oVerflow:=false; ts16_zs(sp)
end;
$df: begin {STX 8}
  ua:=2; doke(peek(adr+1),X); oVerflow:=false; ts16_zs(X)
end;
$90: begin {SUBA 8}
  ua:=2; dec_test(A,peek(peek(adr+1)),oVerflow,Carry);
  A:=A-peek(peek(adr+1)); test_zs(A)
end;
$d0: begin {SUBB 8}
  ua:=2; dec_test(B,peek(peek(adr+1)),oVerflow,Carry);
  B:=B-peek(peek(adr+1)); test_zs(B)
end;
{ ---  --- }
$a9: begin {ADCA 8,X}
  ua:=2; btmp:=Carry; inc_test(A+ord(btmp),
    peek(X+peek(adr+1)),oVerflow,Carry,Half_carry);
  A:=A+peek(X+peek(adr+1))+ord(btmp); test_zs(A)
end;
$e9: begin {ADCB 8,X}
  ua:=2; btmp:=Carry; inc_test(B+ord(btmp),
    peek(X+peek(adr+1)),oVerflow,Carry,Half_carry);
  B:=B+peek(X+peek(adr+1))+ord(btmp); test_zs(B)
end;
$ab: begin {ADDA 8,X}
  ua:=2; inc_test(A,peek(X+peek(adr+1)),
    oVerflow,Carry,Half_carry);
  A:=A+peek(X+peek(adr+1)); test_zs(A)
end;
$eb: begin {ADDB 8,X}
  ua:=2; inc_test(B,peek(X+peek(adr+1)),
    oVerflow,Carry,Half_carry);
  B:=B+peek(X+peek(adr+1)); test_zs(B)
end;
$a4: begin {ANDA 8,X}
  ua:=2; A:=A and peek(X+peek(adr+1));
  test_zs(A); oVerflow:=false
end;
$e4: begin {ANDB 8,X}
  ua:=2; B:=B and peek(X+peek(adr+1));
  test_zs(B); oVerflow:=false
end;
$68: begin {ASL 8,X}
  ua:=2; asl(peek(X+peek(adr+1)),tmp1,oVerflow,Carry);
  poke(X+peek(adr+1),tmp1); test_zs(tmp1)
end;
$67: begin {ASR 8,X}
  ua:=2; asr(peek(X+peek(adr+1)),tmp1,oVerflow,Carry);
  poke(X+peek(adr+1),tmp1); test_zs(tmp1)
end;
$a5: begin {BITA 8,X}
  ua:=2; oVerflow:=false; test_zs(A and peek(X+peek(adr+1)))
end;
$e5: begin {BITB 8,X}
  ua:=2; oVerflow:=false; test_zs(B and peek(X+peek(adr+1)))
end;
$6f: begin {CLR 8,X}
  ua:=2; poke(X+peek(adr+1),0);
  Negative:=false; oVerflow:=false; Zero:=true; Carry:=false
end;
$a1: begin {CMPA 8,X}
  ua:=2; dec_test(A,peek(X+peek(adr+1)),oVerflow,Carry);
  test_zs(A-peek(X+peek(adr+1)))
end;
$e1: begin {CMPB 8,X}
  ua:=2; dec_test(B,peek(X+peek(adr+1)),oVerflow,Carry);
  test_zs(B-peek(X+peek(adr+1)))
end;
$63: begin {COM 8,X}
  ua:=2; poke(X+peek(adr+1),not peek(X+peek(adr+1)));
  Carry:=true; oVerflow:=false; test_zs(peek(X+peek(adr+1)))
end;
$ac: begin {CPX 8,X}
  ua:=2; test_cpx(X,deek(X+peek(adr+1)),oVerflow);
  ts16_zs(X-deek(X+peek(adr+1)))
end;
$6a: begin {DEC 8,X}
  ua:=2; dec_test(peek(X+peek(adr+1)),1,oVerflow,Zero);
  poke(X+peek(adr+1),peek(X+peek(adr+1))-1);
  test_zs(peek(X+peek(adr+1)))
end;
$a8: begin {EORA 8,X}
  ua:=2; A:=A xor peek(X+peek(adr+1));
  test_zs(A); oVerflow:=false
end;
$e8: begin {EORB 8,X}
  ua:=2; B:=B xor peek(X+peek(adr+1));
  test_zs(B); oVerflow:=false
end;
$6c: begin {INC 8,X}
  ua:=2; inc_test(peek(X+peek(adr+1)),1,oVerflow,Zero,Zero);
  poke(X+peek(adr+1),peek(X+peek(adr+1))+1);
  test_zs(peek(X+peek(adr+1)))
end;
$6e: begin {JMP 8,X}
  ua:=0; adr:=deek(peek(adr+1)+x)
end;
$ad: begin {JSR 8,X}
  ua:=0; dec(sp,2); doke(sp,adr+2); adr:=deek(peek(adr+1)+x)
end;
$a6: begin {LDAA 8,X}
  ua:=2; A:=peek(X+peek(adr+1)); test_zs(A); oVerflow:=false
end;
$e6: begin {LDAB 8,X}
  ua:=2; B:=peek(X+peek(adr+1)); test_zs(B); oVerflow:=false
end;
$ae: begin {LDS 8,X}
  ua:=2; sp:=deek(X+peek(adr+1)); oVerflow:=false; ts16_zs(sp)
end;
$ee: begin {LDX 8,X}
  ua:=2; X:=deek(X+peek(adr+1)); oVerflow:=false; ts16_zs(X)
end;
$64: begin {LSR 8,X}
  ua:=2; lsr(peek(X+peek(adr+1)),tmp1);
  poke(X+peek(adr+1),tmp1); test_zs(tmp1)
end;
$60: begin {NEG 8,X}
  ua:=2; dec_test(0,peek(X+peek(adr+1)),oVerflow,Carry);
  poke(X+peek(adr+1),-peek(X+peek(adr+1)));
  test_zs(peek(X+peek(adr+1)))
end;
$aa: begin {ORAA 8,X}
  ua:=2; A:=A or peek(X+peek(adr+1));
  test_zs(A); oVerflow:=false
end;
$ea: begin {ORAB 8,X}
  ua:=2; B:=B or peek(X+peek(adr+1));
  test_zs(B); oVerflow:=false
end;
$69: begin {ROL 8,X}
  ua:=2; rol(peek(X+peek(adr+1)),Carry,tmp1,oVerflow,Carry);
  poke(X+peek(adr+1),tmp1); test_zs(tmp1)
end;
$66: begin {ROR 8,X}
  ua:=2; ror(peek(X+peek(adr+1)),Carry,tmp1,oVerflow,Carry);
  poke(X+peek(adr+1),tmp1); test_zs(tmp1)
end;
$a2: begin {SBCA 8,X}
  ua:=2; btmp:=Carry; dec_test(A-ord(btmp),
    peek(X+peek(adr+1)),oVerflow,Carry);
  A:=A-peek(X+peek(adr+1))-ord(btmp); test_zs(A)
end;
$e2: begin {SBCB 8,X}
  ua:=2; btmp:=Carry; dec_test(B-ord(btmp),
    peek(X+peek(adr+1)),oVerflow,Carry);
  B:=B-peek(X+peek(adr+1))-ord(btmp); test_zs(B)
end;
$a7: begin {STAA 8,X}
  ua:=2; poke(X+peek(adr+1),A); test_zs(A); oVerflow:=false
end;
$e7: begin {STAB 8,X}
  ua:=2; poke(X+peek(adr+1),B); test_zs(B); oVerflow:=false
end;
$af: begin {STS 8,X}
  ua:=2; doke(X+peek(adr+1),sp); oVerflow:=false; ts16_zs(sp)
end;
$ef: begin {STX 8,X}
  ua:=2; doke(X+peek(adr+1),X); oVerflow:=false; ts16_zs(X)
end;
$a0: begin {SUBA 8,X}
  ua:=2; dec_test(A,peek(X+peek(adr+1)),oVerflow,Carry);
  A:=A-peek(X+peek(adr+1)); test_zs(A)
end;
$e0: begin {SUBB 8,X}
  ua:=2; dec_test(B,peek(X+peek(adr+1)),oVerflow,Carry);
  B:=B-peek(X+peek(adr+1)); test_zs(B)
end;
$6d: begin {TST 8,X}
  ua:=2; Carry:=false; oVerflow:=false;
  test_zs(peek(X+peek(adr+1)))
end;
{ ---  --- }
$b9: begin {ADCA 16}
  ua:=3; btmp:=Carry; inc_test(A+ord(btmp),
    peek(deek(adr+1)),oVerflow,Carry,Half_carry);
  A:=A+peek(deek(adr+1))+ord(btmp); test_zs(A)
end;
$f9: begin {ADCB 16}
  ua:=3; btmp:=Carry; inc_test(B+ord(btmp),
    peek(deek(adr+1)),oVerflow,Carry,Half_carry);
  B:=B+peek(deek(adr+1))+ord(btmp); test_zs(B)
end;
$bb: begin {ADDA 16}
  ua:=3; inc_test(A,peek(deek(adr+1)),
    oVerflow,Carry,Half_carry);
  A:=A+peek(deek(adr+1)); test_zs(A)
end;
$fb: begin {ADDB 16}
  ua:=3; inc_test(B,peek(deek(adr+1)),
    oVerflow,Carry,Half_carry);
  B:=B+peek(deek(adr+1)); test_zs(B)
end;
$b4: begin {ANDA 16}
  ua:=3; A:=A and peek(deek(adr+1));
  test_zs(A); oVerflow:=false
end;
$f4: begin {ANDB 16}
  ua:=3; B:=B and peek(deek(adr+1));
  test_zs(B); oVerflow:=false
end;
$78: begin {ASL 16}
  ua:=3; asl(peek(deek(adr+1)),tmp1,oVerflow,Carry);
  poke(deek(adr+1),tmp1); test_zs(tmp1)
end;
$77: begin {ASR 16}
  ua:=3; asr(peek(deek(adr+1)),tmp1,oVerflow,Carry);
  poke(deek(adr+1),tmp1); test_zs(tmp1)
end;
$b5: begin {BITA 16}
  ua:=3; oVerflow:=false; test_zs(A and peek(deek(adr+1)))
end;
$f5: begin {BITB 16}
  ua:=3; oVerflow:=false; test_zs(B and peek(deek(adr+1)))
end;
$7f: begin {CLR 16}
  ua:=3; poke(deek(adr+1),0); Negative:=false;
  oVerflow:=false; Zero:=true; Carry:=false
end;
$b1: begin {CMPA 16}
  ua:=3; dec_test(A,peek(deek(adr+1)),oVerflow,Carry);
  test_zs(A-peek(deek(adr+1)))
end;
$f1: begin {CMPB 16}
  ua:=3; dec_test(B,peek(deek(adr+1)),oVerflow,Carry);
  test_zs(B-peek(deek(adr+1)))
end;
$73: begin {COM 16}
  ua:=3; poke(deek(adr+1),not peek(deek(adr+1)));
  Carry:=true; oVerflow:=false; test_zs(peek(deek(adr+1)))
end;
$bc: begin {CPX 16}
  ua:=3; test_cpx(X,deek(deek(adr+1)),oVerflow);
  ts16_zs(X-deek(deek(adr+1)))
end;
$7a: begin {DEC 16}
  ua:=3; dec_test(peek(deek(adr+1)),1,oVerflow,Zero);
  poke(deek(adr+1),peek(deek(adr+1))-1);
  test_zs(peek(deek(adr+1)))
end;
$b8: begin {EORA 16}
  ua:=3; A:=A xor peek(deek(adr+1));
  test_zs(A); oVerflow:=false
end;
$f8: begin {EORB 16}
  ua:=3; B:=B xor peek(deek(adr+1));
  test_zs(B); oVerflow:=false
end;
$7c: begin {INC 16}
  ua:=3; inc_test(peek(deek(adr+1)),1,oVerflow,Zero,Zero);
  poke(deek(adr+1),peek(deek(adr+1))+1);
  test_zs(peek(deek(adr+1)))
end;
$7e: begin {JMP 16}
  ua:=0; adr:=deek(adr+1)
end;
$bd: begin {JSR 16}
  ua:=0; dec(sp,2); doke(sp,adr+3); adr:=deek(adr+1)
end;
$b6: begin {LDAA 16}
  ua:=3; A:=peek(deek(adr+1)); test_zs(A); oVerflow:=false
end;
$f6: begin {LDAB 16}
  ua:=3; B:=peek(deek(adr+1)); test_zs(B); oVerflow:=false
end;
$be: begin {LDS 16}
  ua:=3; sp:=deek(deek(adr+1)); oVerflow:=false; ts16_zs(sp)
end;
$fe: begin {LDX 16}
  ua:=3; X:=deek(deek(adr+1)); oVerflow:=false; ts16_zs(X)
end;
$74: begin {LSR 16}
  ua:=3; lsr(peek(deek(adr+1)),tmp1);
  poke(deek(adr+1),tmp1); test_zs(tmp1)
end;
$70: begin {NEG 16}
  ua:=3; dec_test(0,peek(deek(adr+1)),oVerflow,Carry);
  poke(deek(adr+1),-peek(deek(adr+1)));
  test_zs(peek(deek(adr+1)))
end;
$ba: begin {ORAA 16}
  ua:=3; A:=A or peek(deek(adr+1));
  test_zs(A); oVerflow:=false
end;
$fa: begin {ORAB 16}
  ua:=3; B:=B or peek(deek(adr+1));
  test_zs(B); oVerflow:=false
end;
$79: begin {ROL 16}
  ua:=3; rol(peek(deek(adr+1)),Carry,tmp1,oVerflow,Carry);
  poke(deek(adr+1),tmp1); test_zs(tmp1)
end;
$76: begin {ROR 16}
  ua:=3; ror(peek(deek(adr+1)),Carry,tmp1,oVerflow,Carry);
  poke(deek(adr+1),tmp1); test_zs(tmp1)
end;
$b2: begin {SBCA 16}
  ua:=3; btmp:=Carry; dec_test(A-ord(btmp),
    peek(deek(adr+1)),oVerflow,Carry);
  A:=A-peek(deek(adr+1))-ord(btmp); test_zs(A)
end;
$f2: begin {SBCB 16}
  ua:=3; btmp:=Carry; dec_test(B-ord(btmp),
    peek(deek(adr+1)),oVerflow,Carry);
  B:=B-peek(deek(adr+1))-ord(btmp); test_zs(B)
end;
$b7: begin {STAA 16}
  ua:=3; poke(deek(adr+1),A); test_zs(A); oVerflow:=false
end;
$f7: begin {STAB 16}
  ua:=3; poke(deek(adr+1),B); test_zs(B); oVerflow:=false
end;
$bf: begin {STS 16}
  ua:=3; doke(deek(adr+1),sp); oVerflow:=false; ts16_zs(sp)
end;
$ff: begin {STX 16}
  ua:=3; doke(deek(adr+1),X); oVerflow:=false; ts16_zs(X)
end;
$b0: begin {SUBA 16}
  ua:=3; dec_test(A,peek(deek(adr+1)),oVerflow,Carry);
  A:=A-peek(deek(adr+1)); test_zs(A)
end;
$f0: begin {SUBB 16}
  ua:=3; dec_test(B,peek(deek(adr+1)),oVerflow,Carry);
  B:=B-peek(deek(adr+1)); test_zs(B)
end;
$7d: begin {TST 16}
  ua:=3; Carry:=false; oVerflow:=false;
  test_zs(peek(deek(adr+1)))
end
else ua:=1 {NOP  । 樨}
{ ------------------- }
  end
end;

begin
  { ⮢  ⪠ : }
  for i:=0 to $f do new(statmas[i]);
  for tmp21:=0 to $bfff do poke(tmp21,0);
  for tmp21:=$e000 to $efff do poke(tmp21,0);
  {  室 䠩: } open_file;
  repeat
    {  믮 ணࠬ: }
    sh:=peek(adr); cc_to_flags; Processor;
    poke(6,A); poke(5,B); doke(7,X);
    Make_CC; inc(adr,ua)
    {    譨 RTS,   㪠 bsp:=0 }
  until sp>bsp;
  for i:=0 to $f do dispose(statmas[i])
end { Emul601 }.